Codeforces Round #352 (Div. 1) B. Robin Hood

7 篇文章 0 订阅
B. Robin Hood
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

Input

The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

Output

Print a single line containing the difference between richest and poorest peoples wealth.

Examples
input
4 1
1 1 4 2
output
2
input
3 1
2 2 2
output
0
题意是有n个人,第i人有ci的钱,每天从最有钱的那个人里拿一块钱给最穷的那个人,(如果最穷和最有钱一样的话则不操作),问k天之后,最有钱的人和最穷的人差多少钱。
直接模拟复杂度极高,我们分析一下可以发现如果k足够大的情况应该是最穷的人有(|sum/n(向下取整)),最有钱的人有(sum/n (向上取整)),我们设k天之后最有钱的人有y块钱,最穷的人有x块钱,我们假设k天之后依旧达不到共产水平,也就是说x < y 。这个时候我们可以假设所有人的钱只增不减,然后二分求出x,再假设所有人的钱只减不增,二分求出y。如果x<y说明就是我们假设的情况了,那么y-x就是答案 ,如果 x >= y那么说明达到共产水平,如果sum%n==0 那么差距就是0 否则差距就是1.
#include<cmath>
#include<algorithm>
#include<cstring>
#include<string>
#include<set>
#include<map>
#include<time.h>
#include<cstdio>
#include<vector>
#include<stack>
#include<queue>
#include<iostream>
using namespace std;
#define  LONG long long
const int   INF=0x3f3f3f3f;
const int   MOD=1e9+7;
const double PI=acos(-1.0);
#define clrI(x) memset(x,-1,sizeof(x))
#define clr0(x) memset(x,0,sizeof x)
#define clr1(x) memset(x,INF,sizeof x)
#define clr2(x) memset(x,-INF,sizeof x)
#define EPS 1e-10
int n ;
LONG  c[500000+20];
LONG   calcu1(int x )
{
    LONG  res =0 ;
    for(int i = 1 ;i <=n ; ++ i)
        if(c[i] < x)
            res += (LONG )(x - c[i]);
        else break ;
    return res ;
}
LONG  calcu2(int x)
{
    LONG  res = 0;
    for(int i = n; i >= 1 ;-- i)
        if(c[i] > x)
            res += (LONG )(c[i] - x);
        else break ;
    return res ;
}
int main()
{
    LONG k ;
    scanf("%d%lld",&n,&k);
    LONG sum = 0;
    for( int i =1; i<= n ;++ i)
    {
        scanf("%lld",&c[i]);
        sum += c[i] ;
    }
    sort(c + 1 , c + n + 1);
    int l = c[1] , r = c[n];
    int mid ;
    while(l < r)
    {
        mid = (l + r + 1)/2;
        if(calcu1(mid) > (LONG )k)
            r = mid - 1;
        else l = mid  ;
    }
    int x = l; //最穷的人有多少钱
    l = c[1] , r = c[n];
    while(l < r)
    {
        mid = (l + r ) / 2;
        if(calcu2(mid) > (LONG )k)
            l = mid + 1;
        else r = mid ;
    }
    int y = l;
    if(  x >= y)
    {
        if(sum % n == 0)
        cout<<0<<endl;
        else cout<<1<<endl;
    }
    else
        cout<< y - x<<endl;
}


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值